.nolist
include \masm32\include\masm32rt.inc
.686
.xmm
include \masm32\macros\timers.asm
LOOP_COUNT	= 100000000

CmpArray1	PROTO: DWORD, :DWORD
CmpArray2	PROTO: DWORD, :DWORD
CmpArray3	PROTO: DWORD, :DWORD
CmpArray4	PROTO: DWORD, :DWORD

.data
Src1	db "This is a string, 32 characters."
Src2	db "This is a string, 32 characters."
.code
start:	invoke Sleep, 200
	rct = 1
	timer_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
	REPEAT rct
		invoke CmpArray1, offset Src1, offset Src2
		ENDM
		mov esi, eax
	timer_end
	print str$(eax), 9, "ticks for CmpArray1, Lingo", 9
	print str$(esi), 13, 10

	timer_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
	REPEAT rct
		invoke CmpArray2, offset Src1, offset Src2
		ENDM
		mov esi, eax
	timer_end
	print str$(eax), 9, "ticks for CmpArray2, Lingo+ret", 9
	print str$(esi), 13, 10

	timer_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
	REPEAT rct
		invoke CmpArray3, offset Src1, offset Src2
		ENDM
		mov esi, eax
	timer_end
	print str$(eax), 9, "ticks for CmpArray3, Clive", 9
	print str$(esi), 13, 10

	timer_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
	REPEAT rct
		invoke CmpArray4, offset Src1, offset Src2
		ENDM
		mov esi, eax
	timer_end
	print str$(eax), 9, "ticks for CmpArray4, dioxin", 9
	print str$(esi), 13, 10

	inkey chr$(13, 10, "--- ok ---", 13)
	exit

Option Prologue:NONE
Option Epilogue:NONE
align 16
CmpArray1 proc strA, strB	; Lingo
	pop ecx
	pop eax
	pop edx
	movdqa xmm0, [eax]
	movdqa xmm1, [eax+16]
;	int 3
	pcmpeqd xmm0, [edx]
	pcmpeqd xmm1, [edx+16]
	pmovmskb eax, xmm0
	pmovmskb edx, xmm1
	shl eax, 16
	add eax, edx
	jmp ecx
CmpArray1 endp

align 16
CmpArray2 proc strA, strB	; Lingo but "normal" ret
	mov eax, [esp+4]
	mov edx, [esp+8]
	movdqa xmm0, [eax]
	movdqa xmm1, [eax+16]
;	int 3	; OPT_Olly 2
	pcmpeqd xmm0, [edx]
	pcmpeqd xmm1, [edx+16]
	pmovmskb eax, xmm0
	pmovmskb edx, xmm1
	shl eax, 16
	add eax, edx
	ret 8
CmpArray2 endp

align 16
CmpArray3 proc strA, strB	; Clive
	pop ecx
	pop eax
	pop edx
	movdqa xmm0, [eax]
	movdqa xmm2, [edx]
	movdqa xmm1, [eax+16]
	movdqa xmm3, [edx+16]
;	int 3
	pcmpeqd xmm0, xmm2
	pmovmskb eax, xmm0
	pcmpeqd xmm1, xmm3
	pmovmskb edx, xmm1
	and eax, edx
	jmp ecx
CmpArray3 endp

align 16
CmpArray4 proc strA, strB	; dioxin
	pop ecx
	pop eax
	pop edx
	movdqa xmm0, [eax]
	movdqa xmm1, [eax+16]
;	int 3
	pcmpeqd xmm0, [edx]
	pcmpeqd xmm1, [edx+16]
	pand xmm0, xmm1
	pmovmskb eax, xmm0
	jmp ecx
CmpArray4 endp

end start

RichMasm options:

OPT_Tmp2Asm	1
OPT_Assembler	ml
OPT_Wait	0

Check also the [url=\masm32\RichMasm\RES\TimingsMacro.asc]timings macro[/url]